%define major 1.4
%define minor 2
%define build 01
%define distversion %major.%minor-%build
%define arch i586
%define origin blackdown
%define priority 142

%define jdkver %major.%minor
%define label %major-%origin

Name: j2se%label
Version: %{jdkver}_%{build}
Release: alt1

%def_disable ns4_plugin

Summary: Java 2 Runtime Environment, Standard Edition
Group: System/Base
License: Sun Binary Code License
URL: http://www.blackdown.org/java-linux.html

Packager: Mikhail Zabaluev <mhz@altlinux.ru>

%define distname    j2sdk-%distversion-linux-%arch.bin
%define java_home   %_libdir/j2se%label
%define libarch	    i386
%define fontdir     %_datadir/fonts/j2se-sun

%define mozplugindir %java_home/jre/plugin/%libarch/mozilla

# TODO:
# - replace font.properties with font.properties.Redhat6.1
#   (or our customization)?

Provides: j2se = %jdkver
Provides: jre = %jdkver, java2 = %jdkver

Requires: j2se-sun-fonts
Requires: java-common
Requires: /proc
Requires(post,preun): alternatives >= 0.2.0

Obsoletes: %name-fonts

Source0: %distname
Source3: %name-javaws.sh

BuildArch: %arch

%add_findprov_lib_path %java_home/jre/lib/%libarch
%add_findprov_lib_path %java_home/jre/lib/%libarch/client
%add_findprov_lib_path %java_home/jre/lib/%libarch/server
%add_findprov_lib_path %java_home/jre/lib/%libarch/native_threads

%define _compress_method gzip

%define _verify_elf_method rpath=relaxed,textrel=relaxed

%package devel
Summary: Java 2 SDK, Standard Edition
Group: Development/Java
Provides: j2se-devel = %jdkver
Provides: jdk = %jdkver, j2sdk = %jdkver
Requires: %name = %version-%release
Requires(post,preun): alternatives >= 0.2.0

%package source
Summary: Source files for the Java 2 SDK
Group: Development/Java

%package demo
Summary: Demo applets and programs for the Java 2 SDK
Group: Development/Java
AutoReqProv: no

%package plugin-mozilla
Summary: Java Plug-In for Mozilla and Netscape 6
Group: Networking/WWW
Provides: java2-plugin-mozilla = %jdkver
Requires: %name = %version-%release
Requires: mozilla
Requires(post,preun): alternatives >= 0.2.0

%if_enabled ns4_plugin
%package plugin-netscape4
Summary: Java Plug-In for Netscape 4.x
Group: Networking/WWW
Provides: java2-plugin-netscape4 = %jdkver
Requires: %name = %version-%release
Requires: netscape-common
Requires(post,preun): alternatives >= 0.2.0
%endif

%package jdbc
Summary: Native library for JDBC support in Java
Group: Development/Databases
Provides: j2se-jdbc = %jdkver
Requires: %name = %version-%release

%package javaws
Summary: Java Web Start
Group: Networking/Other
Provides: javaws = %jdkver
Requires: %name = %version-%release
Requires(post,preun): alternatives >= 0.2.0

%description
The Java 2 Runtime Environment contains the Java virtual machine, 
runtime class libraries, and Java application launcher that are 
necessary to run programs written in the Java programming language. 
It is not a development environment and does not contain development 
tools such as compilers or debuggers.  For development tools, see the 
Java 2 SDK, Standard Edition.

This package contains J2SE Runtime Environment created by the
Blackdown project based on the source code licensed from Sun Microsystems.
Install this package if you need to run Java applications.

%description devel
The Java 2 SDK is a development environment for building applications,
applets, and components using the Java programming language.

The Java 2 SDK includes tools useful for developing and testing programs
written in the Java programming language and running on the Java platform.

This package contains J2SE SDK created by the Blackdown project
based on the source code licensed from Sun Microsystems.
Install this package if you need to develop and build Java applications.

%description source
Java programming language source files for all classes that make up
the Java 2 core API.

%description demo
Examples, with source code, of programming for the Java platform. These include
examples that use Swing and other Java Foundation Classes, and the Java
Platform Debugger Architecture.

%description plugin-mozilla
This package contains Java(TM) 2 Plug-In for Mozilla and Netsape 6/7
web browsers.

%if_enabled ns4_plugin
%description plugin-netscape4
This package contains Java(TM) 2 Plug-In for Netsape 4.x web browser.
%endif

%description jdbc
This package contains a native dynamic library that provides JDBC support
for the Java platform via the ODBC interface. This library is a part of
the Blackdown J2SE bundle.

%description javaws
Java Web Start is a deployment solution for Java-technology-based
applications. It is the plumbing between the computer and the Internet
that allows the user to launch and manage applications right off the
Web. Java Web Start provides easy, one-click activation of
applications, and guarantees that you are always running the latest
version of the application, eliminating complicated installation or
upgrade procedures.

This package provides the Java Web Start installation that is bundled
with J2SE Runtime Environment created by the Blackdown project based
on the source code licensed from Sun Microsystems.

%prep
%setup -T -n %name-%version -c
MORE=10000 sh %SOURCE0 <<EOF ||:
yes
EOF
cd j2sdk%jdkver
# fix perms
chmod -R u+w *

echo j2se >j2se-buildreq-substitute
echo j2se-devel >j2se-devel-buildreq-substitute

cat >README.alt <<EOF
The Java 2 Runtime Environment and SDK, Standard Edition are distributed
within this and related packages as shown below:

%name		- Java 2 Runtime Environment, Standard Edition
			  (with notable omissions listed below).
%name-devel	- Java 2 SDK, Standard Edition.
%name-source	- Java 2 Standard Edition API source files.
%name-demo	- Java 2 SDK demo applets and programs.
%name-jdbc	- JDBC provider library using ODBC.
			  This library was excluded from the
			  %name package due to outstanding dependencies.
%name-javaws	- Java Web Start software that is bundled with
			  Java 2 Runtime Environment, Standard Edition
%name-plugin-mozilla	- Java 2 plug-in for Mozilla and Netscape 6/7.
%name-plugin-netscape4	- Java 2 plug-in for Netscape 4.x (optional).

These packages use the TrueType fonts in %fontdir,
provided by a Sun J2SDK binary distribution and shared between
various installations of the Java 2 Runtime Environment.

See the README, LICENSE, COPYRIGHT, and THIRDPARTYLICENSEREADME.txt files
for copyright information, terms of use and redistribution covering contents
of these packages.
EOF

%install
cd j2sdk%jdkver
# Main files
install -d -m755 $RPM_BUILD_ROOT%java_home
cp -a bin include lib $RPM_BUILD_ROOT%java_home
install -d -m755 $RPM_BUILD_ROOT%java_home/jre
cp -a jre/{bin,javaws,lib,plugin,ControlPanel.html} $RPM_BUILD_ROOT%java_home/jre

# Install profile scripts
cat >$RPM_BUILD_ROOT%java_home/j2se.sh <<EOF
JAVA_HOME=%java_home
export JAVA_HOME
EOF
chmod 755 $RPM_BUILD_ROOT%java_home/j2se.sh
cat >$RPM_BUILD_ROOT%java_home/j2se.csh <<EOF
setenv JAVA_HOME %java_home
EOF
chmod 755 $RPM_BUILD_ROOT%java_home/j2se.csh

# Demo and sources
install -d -m755 $RPM_BUILD_ROOT%_datadir/%name
cp -a demo $RPM_BUILD_ROOT%_datadir/%name
install -m644 src.zip $RPM_BUILD_ROOT%_datadir/%name

# Link the fonts location to the shared fonts directory
rm -rf $RPM_BUILD_ROOT%java_home/jre/lib/fonts
ln -s %fontdir $RPM_BUILD_ROOT%java_home/jre/lib/fonts

# Java Web Start binary
install -m755 %SOURCE3 $RPM_BUILD_ROOT%java_home/jre/javaws/javaws-%_vendor

# Move and label the manpages
mkdir -p $RPM_BUILD_ROOT%_man1dir
for f in man/man1/*; do
    install -p -m644 $f $RPM_BUILD_ROOT%_man1dir/$(basename $f .1.gz)%label.1.gz
done

# Install substitute rules for buildreq
mkdir -p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d
install -m644 j2se-buildreq-substitute \
    $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%name
install -m644 j2se-devel-buildreq-substitute \
    $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%name-devel

%__install -d $RPM_BUILD_ROOT%_altdir

# J2SE alternative
%__cat <<EOF >%buildroot%_altdir/%name-j2se
%_libdir/j2se	%java_home	%priority
%_man1dir/java.1.gz	%_man1dir/java%{label}.1.gz	%java_home
EOF
# binaries and manuals
for i in keytool policytool servertool
do
  %__cat <<EOF >>%buildroot%_altdir/%name-j2se
%_bindir/$i	%java_home/jre/bin/$i	%java_home
%_man1dir/$i.1.gz	%_man1dir/${i}%{label}.1.gz	%java_home
EOF
done
# server binaries
for i in orbd rmid rmiregistry tnameserv
do
  %__cat <<EOF >>%buildroot%_altdir/%name-j2se
%_sbindir/$i	%java_home/jre/bin/$i	%java_home
%_man1dir/$i.1.gz	%_man1dir/${i}%{label}.1.gz	%java_home
EOF
done

# Javac alternative
%__cat <<EOF >%buildroot%_altdir/%name-javac
%_bindir/javac	%java_home/bin/javac	%priority
%_libdir/jdk	%java_home	%java_home/bin/javac
%_man1dir/javac.1.gz	%_man1dir/javac%{label}.1.gz	%java_home/bin/javac
EOF
# binaries and manuals
for i in appletviewer extcheck idlj jar jarsigner javadoc javah javap jdb native2ascii rmic serialver
do
  %__cat <<EOF >>%buildroot%_altdir/%name-javac
%_bindir/$i	%java_home/bin/$i	%java_home/bin/javac
%_man1dir/$i.1.gz	%_man1dir/${i}%{label}.1.gz	%java_home/bin/javac
EOF
done
# profiles
for i in j2se.sh j2se.csh
do
  %__cat <<EOF >>%buildroot%_altdir/%name-javac
%_sysconfdir/profile.d/$i	%java_home/$i	%java_home/bin/javac
EOF
done

# Mozilla plugin alternative
%__cat <<EOF >%buildroot%_altdir/%name-mozilla
%_libdir/mozilla/plugins/libjavaplugin_oji.so	%mozplugindir/libjavaplugin_oji.so	%priority
EOF

# Netscape 4.x plugin alternative
%__cat <<EOF >%buildroot%_altdir/%name-ns4
%_libdir/netscape/plugins/javaplugin.so	%java_home/jre/plugin/%libarch/netscape4/javaplugin.so	%priority
EOF

# Java Web Start alternative
%__cat <<EOF >%buildroot%_altdir/%name-javaws
%_bindir/javaws	%java_home/jre/bin/javaws-%_vendor	%priority
%_man1dir/javaws.1.gz	%_man1dir/javaws%label.1.gz	%java_home/jre/bin/javaws
EOF

%post
%register_alternatives %name-j2se

%pre
[ -L %java_home/jre/lib/fonts ] || %__rm -rf %java_home/jre/lib/fonts

%preun
%unregister_alternatives %name-j2se

%post devel
%register_alternatives %name-javac

%preun devel
%unregister_alternatives %name-javac

%post plugin-mozilla
if [ -d %_libdir/mozilla/plugins ]; then
%register_alternatives %name-mozilla
fi

%preun plugin-mozilla
%unregister_alternatives %name-mozilla

%if_enabled ns4_plugin
%post plugin-netscape4
if [ -d %_libdir/netscape/plugins ]; then
%register_alternatives %name-ns4
fi

%preun plugin-netscape4
%unregister_alternatives %name-ns4
%endif

%post javaws
%register_alternatives %name-javaws

%preun javaws
%unregister_alternatives %name-javaws

%files
%doc j2sdk%jdkver/jre/CHANGES
%doc j2sdk%jdkver/jre/COPYRIGHT
%doc j2sdk%jdkver/jre/LICENSE
%doc j2sdk%jdkver/jre/*README*
%doc j2sdk%jdkver/README.alt
%_altdir/%name-j2se
%_sysconfdir/buildreqs/packages/substitute.d/%name
%dir %java_home
%dir %java_home/jre
%dir %java_home/jre/plugin
%dir %java_home/jre/plugin/%libarch
%dir %java_home/jre/lib
%dir %java_home/jre/lib/security
%dir %_datadir/%name
%java_home/jre/ControlPanel.html
%java_home/jre/bin
%java_home/jre/lib/%libarch
%exclude %java_home/jre/lib/%libarch/libJdbcOdbc.so
%java_home/jre/lib/*.jar
%java_home/jre/lib/*.txt
%java_home/jre/lib/applet
%java_home/jre/lib/audio
%java_home/jre/lib/cmm
%java_home/jre/lib/ext
%java_home/jre/lib/fonts
%java_home/jre/lib/im
%java_home/jre/lib/images
%java_home/jre/lib/locale
%java_home/jre/lib/zi
%config(noreplace) %java_home/jre/lib/*.properties
%config(noreplace) %java_home/jre/lib/*.properties.??
%config(noreplace) %java_home/jre/lib/%libarch/jvm.cfg
%config(noreplace) %java_home/jre/lib/security/cacerts
%config(noreplace) %java_home/jre/lib/security/java.policy
%config(noreplace) %java_home/jre/lib/security/java.security
%doc %java_home/jre/lib/%libarch/*/Xusage.txt
%java_home/jre/lib/security/*.jar
%_man1dir/java%label.1*
%_man1dir/keytool%label.1*
%_man1dir/kinit%label.1*
%_man1dir/klist%label.1*
%_man1dir/ktab%label.1*
%_man1dir/orbd%label.1*
%_man1dir/policytool%label.1*
%_man1dir/rmid%label.1*
%_man1dir/rmiregistry%label.1*
%_man1dir/servertool%label.1*
%_man1dir/tnameserv%label.1*

%files devel
%doc j2sdk%jdkver/*README*
%doc j2sdk%jdkver/LICENSE
%doc j2sdk%jdkver/COPYRIGHT
%_altdir/%name-javac
%_sysconfdir/buildreqs/packages/substitute.d/%name-devel
%config %java_home/j2se.*sh
%java_home/bin
%java_home/lib
%java_home/include
%_man1dir/appletviewer%label.1*
%_man1dir/extcheck%label.1*
%_man1dir/idlj%label.1*
%_man1dir/jar%label.1*
%_man1dir/jarsigner%label.1*
%_man1dir/javac%label.1*
%_man1dir/javadoc%label.1*
%_man1dir/javah%label.1*
%_man1dir/javap%label.1*
%_man1dir/jdb%label.1*
%_man1dir/native2ascii%label.1*
%_man1dir/rmic%label.1*
%_man1dir/serialver%label.1*

%files source
%_datadir/%name/src.zip

%files demo
%_datadir/%name/demo

%files plugin-mozilla
%_altdir/%name-mozilla
%mozplugindir

%if_enabled ns4_plugin
%files plugin-netscape4
%_altdir/%name-ns4
%java_home/jre/plugin/%libarch/netscape4
%endif

%files jdbc
%java_home/jre/lib/%libarch/libJdbcOdbc.so

%files javaws
%doc j2sdk%jdkver/README.alt
%_altdir/%name-javaws
%dir %java_home/jre/javaws
%java_home/jre/javaws/javaws
%java_home/jre/javaws/javawsbin
%java_home/jre/javaws/javaws-%_vendor
%java_home/jre/javaws/*.jar
%java_home/jre/javaws/*.gif
%doc %java_home/jre/javaws/*.html
%java_home/jre/javaws/resources
%config(noreplace) %java_home/jre/javaws/javaws.policy
%config(noreplace) %java_home/jre/javaws/cacerts
%_man1dir/javaws%label.1*

%changelog
* Tue Jan 25 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2_01-alt1
- Updated to the 1.4.2 upstream release
- Homogenized with the latest j2se1.4-sun package

* Sun Aug 29 2004 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt5
- Move to even newer alternatives format
- Requires /proc

* Wed Jun 16 2004 Stanislav Ievlev <inger@altlinux.org> 1.4.1_01-alt4.1
- NMU: move to new alternatives scheme

* Sat Dec 20 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt4
- Added /usr/sbin/update-alternatives to install-time dependencies

* Wed Nov 12 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt3
- Obsoletes j2se1.4-blackdown-fonts (bug #3243)
- Corrected build directory
- Relaxed textrel check on ELF files

* Mon Oct 20 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt2
- Sync with the latest j2se1.4-sun
- Removed fonts package; j2se1.4-blackdown has got symlink
  to the fonts directory provided by j2se-sun-fonts
- Added locations of binary libraries to findprov lib path

* Tue Feb 18 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt1
- Ported from the j2se1.4-sun package
